#!/bin/bash
# run as enstore/package_enstore_bin.sh from directory above enstore
NAME=encp_dcache_bin
if [[ ! -v VERSION ]]; then
    VERSION=0.0
fi
if [[ ! -v REL ]]; then
    REL=7
fi
VERS=${NAME}-${VERSION}

if [ ! -d enstore ]; then
   echo "`basename $0` is expecting to be executed as enstore/packaging/`basename $0`" >&2
   exit 1
fi

# Create rpm build environment
echo "%_topdir ${HOME}/rpm" > ~/.rpmmacros
echo "%_tmppath /tmp" >> ~/.rpmmacros
#rm -rf ~/rpm
mkdir -p ~/rpm/BUILD ~/rpm/RPMS ~/rpm/SOURCES ~/rpm/SPECS ~/rpm/SRPMS
sed -e "s/__VERSION__/${VERSION}/g" -e "s/__RELEASE__/${REL}/g" ./enstore/spec/encp_dcache.spec >  ~/rpm/SPECS/encp_dcache.spec

# Package product for rpmbuild
export ENSTORE_INSTALL_DIR=$HOME/encp_dcache_bin_dir/${VERS}
if [ ! -d $ENSTORE_INSTALL_DIR ]; then
    mkdir -p $ENSTORE_INSTALL_DIR
fi

pushd .
cd enstore/pyinstaller
make clean; make encp_dcache
popd
mkdir -p $ENSTORE_INSTALL_DIR/doc
mkdir -p $ENSTORE_INSTALL_DIR/bin
mkdir -p $ENSTORE_INSTALL_DIR/external_distr
cp $ENSTORE_DIR/README $ENSTORE_INSTALL_DIR
cp $ENSTORE_DIR/LICENSE $ENSTORE_INSTALL_DIR
cp $ENSTORE_DIR/doc/guides/Enstore_Users_Guide.pdf $ENSTORE_INSTALL_DIR/doc
cp $ENSTORE_DIR/doc/guides/Enstore_Small_File_Aggregation_User_Guide.pdf $ENSTORE_INSTALL_DIR/doc
cp $ENSTORE_DIR/external_distr/setups.sh $ENSTORE_INSTALL_DIR/external_distr
cp enstore/sbin/EPS $ENSTORE_INSTALL_DIR/bin
cd $ENSTORE_INSTALL_DIR

cd ..
echo "PWD `pwd`"
echo "MAKING ${VERS}.tgz"
tar -czf ${VERS}.tgz ${VERS}
cp ${VERS}.tgz ~/rpm/SOURCES/
echo "Calling rpmbuild"
# Create rpmbuild
rpmbuild -bb ~/rpm/SPECS/encp_dcache.spec || exit 1
