#!/usr/bin/env python
import os
import subprocess

def fill_analysis(src_spec_dir, src_list, out_file):
    cnt = 0
    for f in src_list:
        print(f, cnt)
        with open("{}/{}.spec".format(src_spec_dir, f), 'r') as rf:
            while True:
                l = rf.readline()
                l = l.replace("a = Analysis(", "f{} = Analysis(".format(cnt))
                if cnt > 0 and l.find("#") == 0:
                    # skip comment line                                                                                               
                    continue
		out_file.write(l)
                if l.find(")") == 0:
                    break
                if not l:
                    break
        cnt += 1


def brush_specs(src_spec_dir, src_list):
    for f in src_list:
        print(f)
        with open("{}/{}.spec".format(src_spec_dir, f), 'r') as rf:
            wf = open("{}/{}.spec.tmp".format(src_spec_dir, f), 'w')
            while True:
                l = rf.readline()
                if not l:
                    break
                if l.find(")") >= 0:
                    l = l.replace(")", ",\n)")
                if l.find("#") == 0:
                    # skip comment line
                    continue
                wf.write(l)
            wf.close()
    for f in src_list:
        os.rename("{}/{}.spec".format(src_spec_dir, f), "{}.spec".format(f))
        os.rename("{}/{}.spec.tmp".format(src_spec_dir, f), "{}/{}.spec".format(src_spec_dir, f))
        
def fill_merge(src_list, out_file):
    cnt = 0
    s = []
    s.append("MERGE(")
    for f in src_list:
        s.append("(f{}, '{}', '{}'),".format(cnt, f, f))
        cnt += 1
    s.append(")")
    for l in s:
        out_file.write("{}\n".format(l))

def fill_pyz_exe(src_spec_dir, src_list, out_file):
    cnt = 0
    for f in src_list:
        with open("{}/{}.spec".format(src_spec_dir, f), 'r') as rf:
            stop = False
            while True:
                l = rf.readline()
                print("AAAA:::", l)
                if l.find(")") == 0:
                    break
            while True:
                l = rf.readline()
                print("L:::::::", l)
                l = l.replace("pyz", "pyz{}".format(cnt))
                l = l.replace("exe ", "exe{} ".format(cnt))
                l = l.replace("a.pure", "f{}.pure".format(cnt))
                l = l.replace("a.zipped_data", "f{}.zipped_data".format(cnt))
                l = l.replace("a.scripts", "f{}.scripts".format(cnt))
                if cnt > 0 and l.find("#") == 0:
                    # skip comment line                                                                                     
                    continue
                out_file.write(l)
                if l.find(")") == 0:
                    if not stop:
                        stop = True
                    else:
                        break
                if not l:
                    break
            cnt += 1

def fill_collect(src_list, collection_name, out_file):
    cnt = 0
    s = []
    s.append("coll = COLLECT(")
    for f in src_list:
        s.append("    exe{},".format(cnt))
        s.append("    f{}.binaries,".format(cnt))
        s.append("    f{}.datas,".format(cnt))
        cnt += 1
    s.append("    strip=False,")
    s.append("    upx=True,")
    s.append("    upx_exclude=[],")
    s.append("    name='{}')".format(collection_name))
    for l in s:
        out_file.write("{}\n".format(l))
        
import sys
root = os.getenv('ENSTORE_DIR')
spec_dir = "{}/pyinstaller/specs/".format(root)
src_list = []

with open('spec_list', 'r') as f:
    for line in f.readlines():
        src_list.append(line.strip())

#sys.exit()
with open("specs/enstore_sbin.spec", "w") as of:
    brush_specs(spec_dir, src_list)
    fill_analysis(spec_dir, src_list, of)
    fill_merge(src_list, of)
    fill_pyz_exe(spec_dir, src_list, of)
    fill_collect(src_list, 'sbin', of)

    
